# $Id: diff_15_to_16.sql 16912 2010-05-08 14:23:07Z pasamio $

# 1.5 to 1.6

-- ----------------------------------------------------------------
-- ss_dbprefixassets
-- ----------------------------------------------------------------

CREATE TABLE IF NOT EXISTS `ss_dbprefixassets` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set parent.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `level` int(10) unsigned NOT NULL COMMENT 'The cached level in the nested tree.',
  `name` varchar(50) NOT NULL COMMENT 'The unique name for the asset.\n',
  `title` varchar(100) NOT NULL COMMENT 'The descriptive title for the asset.',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_asset_name` (`name`),
  KEY `idx_lft_rgt` (`lft`,`rgt`),
  KEY `idx_parent_id` (`parent_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- ----------------------------------------------------------------
-- ss_dbprefixbanners
-- ----------------------------------------------------------------

ALTER TABLE `ss_dbprefixbanner`
 RENAME TO `ss_dbprefixbanners`;

ALTER TABLE `ss_dbprefixbanners`
 CHANGE COLUMN `bid` `id` INTEGER NOT NULL auto_increment;
 
ALTER TABLE `ss_dbprefixbanner`
 CHANGE `custombannercode` `custombannercode` varchar(2048) NOT NULL;

ALTER TABLE `ss_dbprefixbanners`
 MODIFY COLUMN `type` INTEGER NOT NULL DEFAULT '0';

ALTER TABLE `ss_dbprefixbanners`
 CHANGE COLUMN `showBanner` `state` TINYINT(3) NOT NULL DEFAULT '0';

ALTER TABLE `ss_dbprefixbanners`
 CHANGE COLUMN `tags` `metakey` TEXT NOT NULL AFTER `state`;

ALTER TABLE `ss_dbprefixbanners`
 CHANGE COLUMN `date` `created` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00' AFTER `params`;

ALTER TABLE `ss_dbprefixbanners`
 DROP COLUMN `editor`;

ALTER TABLE `ss_dbprefixbanners`
 MODIFY COLUMN `catid` INTEGER UNSIGNED NOT NULL DEFAULT 0 AFTER `state`;

ALTER TABLE `ss_dbprefixbanners`
 MODIFY COLUMN `description` TEXT NOT NULL AFTER `catid`;

ALTER TABLE `ss_dbprefixbanners`
 MODIFY COLUMN `sticky` TINYINT(1) UNSIGNED NOT NULL DEFAULT 0 AFTER `description`;

ALTER TABLE `ss_dbprefixbanners`
 MODIFY COLUMN `ordering` INTEGER NOT NULL DEFAULT 0 AFTER `sticky`;

ALTER TABLE `ss_dbprefixbanners`
 MODIFY COLUMN `params` TEXT NOT NULL AFTER `metakey`;

ALTER TABLE `ss_dbprefixbanners`
 ADD COLUMN `own_prefix` TINYINT(1) NOT NULL DEFAULT '0' AFTER `params`;

ALTER TABLE `ss_dbprefixbanners`
 ADD COLUMN `metakey_prefix` VARCHAR(255) NOT NULL DEFAULT '' AFTER `own_prefix`;

ALTER TABLE `ss_dbprefixbanners`
 ADD COLUMN `purchase_type` TINYINT NOT NULL DEFAULT '-1' AFTER `metakey_prefix`;

ALTER TABLE `ss_dbprefixbanners`
 ADD COLUMN `track_clicks` TINYINT NOT NULL DEFAULT '-1' AFTER `purchase_type`;

ALTER TABLE `ss_dbprefixbanners`
 ADD COLUMN `track_impressions` TINYINT NOT NULL DEFAULT '-1' AFTER `track_clicks`;

ALTER TABLE `ss_dbprefixbanners`
 ADD COLUMN `reset` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00' AFTER `publish_down`;

ALTER TABLE `ss_dbprefixbanners`
 ADD COLUMN `language` char(7) NOT NULL DEFAULT '' AFTER `created`;

UPDATE `ss_dbprefixbanners`
 SET `type`=1 WHERE TRIM(`custombannercode`)!='';

UPDATE `ss_dbprefixbanners`
 SET `params` = concat( '"flash":{"', REPLACE( REPLACE( REPLACE( TRIM( '\n' FROM `params` ) , '=', '":"' ) , '\n', '","' ) , '\r', '' ) , '"},' ) WHERE TRIM( `params` ) != '';

UPDATE `ss_dbprefixbanners`
 SET `params` = '"flash":{"height":"0","width":"0"},' WHERE TRIM( `params` ) = '';

UPDATE `ss_dbprefixbanners`
 SET `params` = CONCAT('{"custom":{"bannercode":"',REPLACE(`custombannercode`,'"','\\"'),'"},"alt":{"alt":""},',`params`,'"image":{"url":"',`imageurl`,'"}}');

ALTER TABLE `ss_dbprefixbanners`
 DROP COLUMN `custombannercode`;

ALTER TABLE `ss_dbprefixbanners`
 DROP COLUMN `imageurl`;

ALTER TABLE `ss_dbprefixbanners`
 DROP INDEX `viewbanner`;

ALTER TABLE `ss_dbprefixbanners`
 ADD INDEX `idx_own_prefix` (`own_prefix`);

ALTER TABLE `ss_dbprefixbanners`
 ADD INDEX `idx_metakey_prefix` (`metakey_prefix`);

ALTER TABLE `ss_dbprefixbanners`
 ADD INDEX `idx_language` (`language`);

-- ----------------------------------------------------------------
-- ss_dbprefixbanner_clients
-- ----------------------------------------------------------------

ALTER TABLE `ss_dbprefixbannerclient`
 RENAME TO `ss_dbprefixbanner_clients`;

ALTER TABLE `ss_dbprefixbanner_clients`
 CHANGE COLUMN `cid` `id` INTEGER NOT NULL auto_increment;

ALTER TABLE `ss_dbprefixbanner_clients`
 DROP COLUMN `editor`;

ALTER TABLE `ss_dbprefixbanner_clients`
 ADD COLUMN `state` TINYINT(3) NOT NULL DEFAULT '0' AFTER `extrainfo`;

ALTER TABLE `ss_dbprefixbanner_clients`
 ADD COLUMN `metakey` TEXT NOT NULL;

ALTER TABLE `ss_dbprefixbanner_clients`
 ADD COLUMN `own_prefix` TINYINT NOT NULL DEFAULT '0';

ALTER TABLE `ss_dbprefixbanner_clients`
 ADD COLUMN `metakey_prefix` VARCHAR(255) NOT NULL DEFAULT '';

ALTER TABLE `ss_dbprefixbanner_clients`
 ADD COLUMN `purchase_type` TINYINT NOT NULL DEFAULT '-1';

ALTER TABLE `ss_dbprefixbanner_clients`
 ADD COLUMN `track_clicks` TINYINT NOT NULL DEFAULT '-1';

ALTER TABLE `ss_dbprefixbanner_clients`
 ADD COLUMN `track_impressions` TINYINT NOT NULL DEFAULT '-1';

ALTER TABLE `ss_dbprefixbanner_clients`
 ADD INDEX `idx_own_prefix` (`own_prefix`);

ALTER TABLE `ss_dbprefixbanner_clients`
 ADD INDEX `idx_metakey_prefix` (`metakey_prefix`);

UPDATE `ss_dbprefixbanner_clients`
 SET `state`=1;

-- ----------------------------------------------------------------
-- ss_dbprefixbanner_tracks
-- ----------------------------------------------------------------

ALTER TABLE `ss_dbprefixbannertrack`
 RENAME TO `ss_dbprefixbanner_tracks`;

ALTER TABLE `ss_dbprefixbanner_tracks`
 ADD COLUMN `count` INTEGER UNSIGNED NOT NULL DEFAULT '0';

INSERT `ss_dbprefixbanner_tracks`
 SELECT `track_date`,`track_type`,`banner_id`,count('*') AS `count`
 FROM `ss_dbprefixbanner_tracks`
 GROUP BY `track_date`,`track_type`,`banner_id`;

DELETE FROM `ss_dbprefixbanner_tracks`
 WHERE `count`=0;

ALTER TABLE `ss_dbprefixbanner_tracks`
 ADD PRIMARY KEY (`track_date`, `track_type`, `banner_id`);

ALTER TABLE `ss_dbprefixbanner_tracks`
 ADD INDEX `idx_track_date` (`track_date`);

ALTER TABLE `ss_dbprefixbanner_tracks`
 ADD INDEX `idx_track_type` (`track_type`);

ALTER TABLE `ss_dbprefixbanner_tracks`
 ADD INDEX `idx_banner_id` (`banner_id`);

-- ----------------------------------------------------------------
-- ss_dbprefixcategories
-- ----------------------------------------------------------------

ALTER TABLE `ss_dbprefixcategories`
 MODIFY COLUMN `description` VARCHAR(5120) NOT NULL DEFAULT '';

ALTER TABLE `ss_dbprefixcategories`
 MODIFY COLUMN `params` VARCHAR(2048) NOT NULL DEFAULT '';

ALTER TABLE `ss_dbprefixcategories`
 ADD COLUMN `lft` INTEGER NOT NULL DEFAULT 0 COMMENT 'Nested set lft.' AFTER `parent_id`;

ALTER TABLE `ss_dbprefixcategories`
 ADD COLUMN `rgt` INTEGER NOT NULL DEFAULT 0 COMMENT 'Nested set rgt.' AFTER `lft`;

ALTER TABLE `ss_dbprefixcategories`
 ADD COLUMN `level` INT UNSIGNED NOT NULL DEFAULT 0 AFTER `rgt`;

ALTER TABLE `ss_dbprefixcategories`
 ADD COLUMN `path` VARCHAR(1024) NOT NULL DEFAULT '' AFTER `level`;

ALTER TABLE `ss_dbprefixcategories`
 ADD COLUMN `note` VARCHAR(255) NOT NULL DEFAULT '' AFTER `alias`;

ALTER TABLE `ss_dbprefixcategories`
 ADD COLUMN `metadesc` VARCHAR(1024) NOT NULL COMMENT 'The meta description for the page.' AFTER `params`;

ALTER TABLE `ss_dbprefixcategories`
 ADD COLUMN `metakey` VARCHAR(1024) NOT NULL COMMENT 'The meta keywords for the page.' AFTER `metadesc`;

ALTER TABLE `ss_dbprefixcategories`
 ADD COLUMN `metadata` VARCHAR(2048) NOT NULL COMMENT 'JSON encoded metadata properties.' AFTER `metakey`;

ALTER TABLE `ss_dbprefixcategories`
 ADD COLUMN `created_user_id` INT UNSIGNED NOT NULL DEFAULT 0 AFTER `metadata`;

ALTER TABLE `ss_dbprefixcategories`
 ADD COLUMN `created_time` TIMESTAMP NOT NULL AFTER `created_user_id`;

ALTER TABLE `ss_dbprefixcategories`
 ADD COLUMN `modified_user_id` INT UNSIGNED NOT NULL DEFAULT 0 AFTER `created_time`;

ALTER TABLE `ss_dbprefixcategories`
 ADD COLUMN `modified_time` TIMESTAMP NOT NULL AFTER `modified_user_id`;

ALTER TABLE `ss_dbprefixcategories`
 ADD COLUMN `hits` INT UNSIGNED NOT NULL DEFAULT 0 AFTER `modified_time`;

ALTER TABLE `ss_dbprefixcategories`
 ADD COLUMN `language` CHAR(7) NOT NULL AFTER `hits`;

ALTER TABLE `ss_dbprefixcategories`
 ADD INDEX idx_alias(`alias`);

ALTER TABLE `ss_dbprefixcategories`
 ADD INDEX idx_path(`path`);

ALTER TABLE `ss_dbprefixcategories`
 ADD INDEX idx_left_right(`lft`, `rgt`);

ALTER TABLE `ss_dbprefixcategories`
 ADD INDEX `idx_language` (`language`);

ALTER TABLE `ss_dbprefixcategories`
 DROP COLUMN `ordering`;

-- TODO: Merge from sections and add uncategorised nodes.

-- ----------------------------------------------------------------
-- ss_dbprefixcomponents
-- ----------------------------------------------------------------

ALTER TABLE `ss_dbprefixcomponents`
 MODIFY COLUMN `enabled` TINYINT(4) UNSIGNED NOT NULL DEFAULT 1;

UPDATE `ss_dbprefixcomponents`
 SET admin_menu_link = 'option=com_content&view=articles'
 WHERE link = 'option=com_content';

INSERT INTO `ss_dbprefixcomponents` VALUES
 (null, 'Articles', '', 0, 0, 'option=com_content&view=articles', 'com_content_Articles', 'com_content', 1, '', 1, '{}', 1),
 (null, 'Categories', '', 0, 0, 'option=com_categories&view=categories&extension=com_content', 'com_content_Categories', 'com_content', 2, '', 1, '{}', 1),
 (null, 'Featured', '', 0, 0, 'option=com_content&view=featured', 'com_content_Featured', 'com_content', 3, '', 1, '{}', 1),
 (null, 'Redirects', '', 0, 0, 'option=com_redirect', 'Manage Redirects', 'com_redirect', 0, 'js/ThemeOffice/component.png', 1, '{}', 1),
 (null, 'Checkin', '', 0, 0, 'option=com_checkin', 'Checkin', 'com_checkin', 0, 'js/ThemeOffice/component.png', 1, '{}', 1);

UPDATE `ss_dbprefixcomponents` AS a
 LEFT JOIN `ss_dbprefixcomponents` AS b ON b.link='option=com_content'
 SET a.parent = b.id
 WHERE a.link = ''
  AND a.option = 'com_content';


-- ----------------------------------------------------------------
-- ss_dbprefixcontact_details
-- ----------------------------------------------------------------
 ALTER TABLE `ss_dbprefixcontact_details`
  ADD COLUMN `sortname1` varchar(255) NOT NULL,
  ADD COLUMN `sortname2` varchar(255) NOT NULL,
  ADD COLUMN `sortname3` varchar(255) NOT NULL,
  ADD COLUMN `language` char(7) NOT NULL,
  ADD COLUMN  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  ADD COLUMN   `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  ADD COLUMN   `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  ADD COLUMN   `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  ADD COLUMN   `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  ADD COLUMN   `metakey` text NOT NULL,
  ADD COLUMN   `metadesc` text NOT NULL,
  ADD COLUMN   `metadata` text NOT NULL,
  ADD COLUMN   `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  ADD COLUMN   `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  ADD COLUMN   `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  ADD COLUMN   `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  CHANGE `published` `published` tinyint(1) NOT NULL DEFAULT '0',
  DROP INDEX `catid`,
  ADD  KEY `idx_access` (`access`),
  ADD  KEY `idx_checkout` (`checked_out`),
  ADD  KEY `idx_published` (`published`),
  ADD  KEY `idx_catid` (`catid`),
  ADD  KEY `idx_createdby` (`created_by`),
  ADD  KEY `idx_featured_catid` (`featured`,`catid`),
  ADD  KEY `idx_language` (`language`),
  ADD  KEY `idx_xreference` (`xreference`);
-- ----------------------------------------------------------------
-- ss_dbprefixcontent
-- ----------------------------------------------------------------

ALTER TABLE `ss_dbprefixcontent`
 ADD COLUMN `asset_id` INTEGER UNSIGNED NOT NULL DEFAULT 0 COMMENT 'FK to the ss_dbprefixassets table.' AFTER `id`;

ALTER TABLE `ss_dbprefixcontent`
 ADD COLUMN `featured` TINYINT UNSIGNED NOT NULL DEFAULT 0 COMMENT 'Set if article is featured.' AFTER `metadata`;

ALTER TABLE `ss_dbprefixcontent`
 ADD INDEX idx_featured_catid(`featured`, `catid`);

ALTER TABLE `ss_dbprefixcontent`
 ADD COLUMN `language` CHAR(7) NOT NULL COMMENT 'The language code for the article.' AFTER `featured`;

ALTER TABLE `ss_dbprefixcontent`
 ADD COLUMN `xreference` VARCHAR(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.' AFTER `language`;

ALTER TABLE `ss_dbprefixcontent`
 ADD INDEX idx_language(`language`);

ALTER TABLE `ss_dbprefixcontent`
 ADD INDEX idx_xreference(`xreference`);

UPDATE `ss_dbprefixcontent` AS a
 SET a.featured = 1
 WHERE a.id IN (
 	SELECT f.content_id
 	FROM `ss_dbprefixcontent_frontpage` AS f
 );

 ALTER TABLE `ss_dbprefixcontent` CHANGE `attribs` `attribs` VARCHAR( 5120 ) NOT NULL;

-- ----------------------------------------------------------------
-- ss_dbprefixextensions (new) and migration
-- ----------------------------------------------------------------

CREATE TABLE  `ss_dbprefixextensions` (
  `extension_id` int(11) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `type` varchar(20) NOT NULL default '',
  `element` varchar(100) NOT NULL default '',
  `folder` varchar(100) NOT NULL default '',
  `client_id` tinyint(3) NOT NULL default '0',
  `enabled` tinyint(3) NOT NULL default '1',
  `access` tinyint(3) unsigned NOT NULL default '0',
  `protected` tinyint(3) NOT NULL default '0',
  `manifestcache` text NOT NULL,
  `params` text NOT NULL,
  `custom_data` text NOT NULL,
  `system_data` text NOT NULL,
  `checked_out` int(10) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `ordering` int(11) default '0',
  `state` int(11) NOT NULL default '0',
  PRIMARY KEY  (`extension_id`),
  KEY `type_element` (`type`,`element`),
  KEY `element_clientid` (`element`,`client_id`),
  KEY `element_folder_clientid` (`element`,`folder`,`client_id`),
  KEY `element_folder` (`element`,`folder`),
  KEY `extension` (`type`,`element`,`folder`,`client_id`)
) TYPE=MyISAM CHARACTER SET `utf8`;

TRUNCATE TABLE ss_dbprefixextensions;
INSERT INTO ss_dbprefixextensions SELECT
     0,							# extension id (regenerate)
     name,						# name
     'plugin',					# type
     element,					# element
     folder,                    # folder
     client_id,                 # client_id
     published,                 # enabled
     access,                    # access
     iscore,                    # protected
     '',                        # manifest_cache
     params,                    # params
     '',                        # custom data
     '',						# system data
     checked_out,            	# checked_out
     checked_out_time,         	# checked_out_time
     ordering,                  # ordering
     0							# state
     FROM ss_dbprefixplugins;         	# ss_dbprefixextensions replaces the old ss_dbprefixplugins table

 INSERT INTO ss_dbprefixextensions SELECT
     0,                         # extension id (regenerate)
     name,						# name
     'component',				# type
     `option`,					# element
     '',                        # folder
     0,                         # client id (unused for components)
     enabled,                   # enabled
     0,                         # access
     iscore,                    # protected
     '',                        # manifest cache
     params,                    # params
     '',                        # custom data
     '',						# system data
     '0',                       # checked_out
     '0000-00-00 00:00:00',     # checked_out_time
     0,                         # ordering
     0							# state
     FROM ss_dbprefixcomponents			# ss_dbprefixextensions replaces ss_dbprefixcomponents for install uninstall
                                # component menu selection still utilises the ss_dbprefixcomponents table
     WHERE parent = 0;          # only get top level entries

 INSERT INTO ss_dbprefixextensions SELECT DISTINCT
     0,                         # extension id (regenerate)
     module,                    # name
     'module',                  # type
     `module`,                  # element
     '',                        # folder
     client_id,                 # client id
     1,                         # enabled (module instances may be enabled/disabled in ss_dbprefixmodules)
     0,                         # access (module instance access controlled in ss_dbprefixmodules)
     iscore,                    # protected
     '',                        # manifest cache
     '',                        # params (module instance params controlled in ss_dbprefixmodules)
     '',                        # custom data
     '',						# system data
     '0',                       # checked_out (module instance, see ss_dbprefixmodules)
     '0000-00-00 00:00:00',     # checked_out_time (module instance, see ss_dbprefixmodules)
     0,                         # ordering (module instance, see ss_dbprefixmodules)
     0							# state
     FROM ss_dbprefixmodules			# ss_dbprefixextensions provides the install/uninstall control for modules
     WHERE id IN (SELECT id FROM ss_dbprefixmodules GROUP BY module ORDER BY id);

-- rename mod_newsflash to mod_articles_news
UPDATE `ss_dbprefixextensions` SET `name` = 'mod_articles_news', `element` = 'mod_articles_news' WHERE `name` = 'mod_newsflash';

-- New extensions
INSERT INTO `ss_dbprefixextensions` VALUES(0, 'plg_editors_codemirror', 'plugin', 'codemirror', 'editors', 1, 0, 1, 1, '', 'linenumbers=0\n\n', '', '', 0, '0000-00-00 00:00:00', 7, 0);
INSERT INTO `ss_dbprefixextensions` VALUES(0, 'plg_extension_joomla', 'plugin', 'joomla', 'extension', 0, 1, 1, 0, '', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0);

-- ----------------------------------------------------------------
-- ss_dbprefixlanguages (new)
-- ----------------------------------------------------------------

CREATE TABLE `ss_dbprefixlanguages` (
  `lang_id` int(11) unsigned NOT NULL auto_increment,
  `lang_code` char(7) NOT NULL,
  `title` varchar(50) NOT NULL,
  `title_native` varchar(50) NOT NULL,
  `description` varchar(512) NOT NULL,
  `published` int(11) NOT NULL default '0',
  PRIMARY KEY  (`lang_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8

INSERT INTO `ss_dbprefixlanguages` (`lang_id`,`lang_code`,`title`,`title_native`,`description`,`published`)
VALUES
	(1,'en_GB','English (UK)','English (UK)','',1),
	(2,'en_US','English (US)','English (US)','',1);

-- ----------------------------------------------------------------
-- ss_dbprefixmenu
-- ----------------------------------------------------------------

ALTER TABLE `ss_dbprefixmenu`
 DROP COLUMN `sublevel`,
 DROP COLUMN `pollid`,
 DROP COLUMN `utaccess`;

ALTER TABLE `ss_dbprefixmenu`
 MODIFY COLUMN `menutype` VARCHAR(24) NOT NULL COMMENT 'The type of menu this item belongs to. FK to ss_dbprefixmenu_types.menutype';

ALTER TABLE `ss_dbprefixmenu`
 CHANGE COLUMN `name` `title` VARCHAR(255) NOT NULL COMMENT 'The display title of the menu item.';

ALTER TABLE `ss_dbprefixmenu`
 MODIFY COLUMN `alias` VARCHAR(255) NOT NULL COMMENT 'The SEF alias of the menu item.';

ALTER TABLE `ss_dbprefixmenu`
 ADD COLUMN `note` VARCHAR(255) NOT NULL DEFAULT '' AFTER `alias`;

ALTER TABLE `ss_dbprefixmenu`
 MODIFY COLUMN `link` VARCHAR(1024) NOT NULL COMMENT 'The actually link the menu item refers to.';

ALTER TABLE `ss_dbprefixmenu`
 MODIFY COLUMN `type` VARCHAR(16) NOT NULL COMMENT 'The type of link: Component, URL, Alias, Separator';

ALTER TABLE `ss_dbprefixmenu`
 MODIFY COLUMN `published` TINYINT NOT NULL DEFAULT 0 COMMENT 'The published state of the menu link.';

ALTER TABLE `ss_dbprefixmenu`
 CHANGE COLUMN `parent` `parent_id` INTEGER UNSIGNED NOT NULL DEFAULT 0 COMMENT 'The parent menu item in the menu tree.';

ALTER TABLE `ss_dbprefixmenu`
 ADD COLUMN `level` INT UNSIGNED NOT NULL DEFAULT 0 COMMENT 'The relative level in the tree.' AFTER `parent_id`;

ALTER TABLE `ss_dbprefixmenu`
 CHANGE COLUMN `componentid` `component_id` INTEGER UNSIGNED NOT NULL DEFAULT 0 COMMENT 'FK to ss_dbprefixcomponents.id';

ALTER TABLE `ss_dbprefixmenu`
 MODIFY COLUMN `ordering` INTEGER NOT NULL DEFAULT 0 COMMENT 'The relative ordering of the menu item in the tree.';

ALTER TABLE `ss_dbprefixmenu`
 MODIFY COLUMN `checked_out` INTEGER UNSIGNED NOT NULL DEFAULT 0 COMMENT 'FK to ss_dbprefixusers.id';

ALTER TABLE `ss_dbprefixmenu`
 MODIFY COLUMN `checked_out_time` TIMESTAMP NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'The time the menu item was checked out.';

ALTER TABLE `ss_dbprefixmenu`
 MODIFY COLUMN `browserNav` TINYINT NOT NULL DEFAULT 0 COMMENT 'The click behaviour of the link.';

ALTER TABLE `ss_dbprefixmenu`
 MODIFY COLUMN `access` TINYINT UNSIGNED NOT NULL DEFAULT 0 COMMENT 'The access level required to view the menu item.';

ALTER TABLE `ss_dbprefixmenu`
 MODIFY COLUMN `params` VARCHAR(10240) NOT NULL COMMENT 'JSON encoded data for the menu item.';

ALTER TABLE `ss_dbprefixmenu`
 MODIFY COLUMN `lft` INTEGER NOT NULL DEFAULT 0 COMMENT 'Nested set lft.';

ALTER TABLE `ss_dbprefixmenu`
 MODIFY COLUMN `rgt` INTEGER NOT NULL DEFAULT 0 COMMENT 'Nested set rgt.';

ALTER TABLE `ss_dbprefixmenu`
 MODIFY COLUMN `home` TINYINT UNSIGNED NOT NULL DEFAULT 0 COMMENT 'Indicates if this menu item is the home or default page.';

ALTER TABLE `ss_dbprefixmenu`
 ADD COLUMN `path` VARCHAR(1024) NOT NULL COMMENT 'The computed path of the menu item based on the alias field.' AFTER `alias`;

ALTER TABLE `ss_dbprefixmenu`
 ADD COLUMN `template_style_id` int(11) UNSIGNED NOT NULL DEFAULT '0';

ALTER TABLE `ss_dbprefixmenu`
 ADD COLUMN `language` char(7) NOT NULL DEFAULT '' AFTER `home`;

ALTER TABLE `ss_dbprefixmenu`
 ADD INDEX idx_language(`language`);

INSERT INTO `ss_dbprefixmenu` VALUES
 (0, '', 'Menu_Item_Root', 'root', '', '', '', 1, 0, 0, 0, 0, 0, '0000-00-00 00:00:00', 0, 0, 0, '', 0, 37, 0);

-- TODO: Need to devise how to shift the parent_id's of the existing menus to relate to the new root.
-- UPDATE `ss_dbprefixmenu`
--  SET `parent_id` = (SELECT `id` FROM `ss_dbprefixmenu` WHERE `alias` = 'root')
--  WHERE `alias` != 'root';

-- ----------------------------------------------------------------
-- ss_dbprefixmenu_types
-- ----------------------------------------------------------------

ALTER TABLE `ss_dbprefixmenu_types`
 MODIFY COLUMN `menutype` VARCHAR(24) NOT NULL,
 MODIFY COLUMN `title` VARCHAR(48) NOT NULL,
 DROP INDEX `menutype`;

-- ----------------------------------------------------------------
-- ss_dbprefixmessages
-- ----------------------------------------------------------------

ALTER TABLE `ss_dbprefixmessages`
 CHANGE `subject` `subject` varchar(255) NOT NULL DEFAULT '';

ALTER TABLE `ss_dbprefixmessages`
 CHANGE `state` `state` tinyint(1) NOT NULL DEFAULT '0';

ALTER TABLE `ss_dbprefixmessages`
 CHANGE `priority` `priority` tinyint(1) UNSIGNED NOT NULL DEFAULT '0';

ALTER TABLE `ss_dbprefixmessages`
 CHANGE `folder_id` `folder_id` tinyint(3) UNSIGNED NOT NULL DEFAULT '0';

-- ----------------------------------------------------------------
-- ss_dbprefixmodules
-- ----------------------------------------------------------------

ALTER TABLE `ss_dbprefixmodules`
 DROP `numnews`;

ALTER TABLE `ss_dbprefixmodules`
 DROP `control`;

ALTER TABLE `ss_dbprefixmodules`
 DROP `iscore`;

ALTER TABLE `ss_dbprefixmodules`
 ADD COLUMN `note` VARCHAR(255) NOT NULL DEFAULT '' AFTER `title`;

ALTER TABLE `ss_dbprefixmodules`
 ADD COLUMN `language` CHAR(7) NOT NULL AFTER `client_id`;

ALTER TABLE `ss_dbprefixmodules`
 ADD INDEX `idx_language` (`language`);

ALTER TABLE `ss_dbprefixmodules`
 CHANGE `title` `title` varchar(100) NOT NULL DEFAULT '';

ALTER TABLE `ss_dbprefixmodules`
 CHANGE `params` `params` varchar(5120) NOT NULL DEFAULT '';

ALTER TABLE `ss_dbprefixmodules`
 ADD COLUMN `publish_up` datetime NOT NULL default '0000-00-00 00:00:00' AFTER `checked_out_time`;

ALTER TABLE `ss_dbprefixmodules`
 ADD COLUMN `publish_down` datetime NOT NULL default '0000-00-00 00:00:00' AFTER `publish_up`;

ALTER TABLE `ss_dbprefixmodules`
 ADD COLUMN `language` char(7) NOT NULL DEFAULT '' AFTER `client_id`;

ALTER TABLE `ss_dbprefixmodules`
 ADD INDEX idx_language(`language`);

UPDATE `ss_dbprefixmodules`
 SET `menutype` = 'mod_menu'
 WHERE `menutype` = 'mod_mainmenu';

-- ----------------------------------------------------------------
-- ss_dbprefixnewsfeeds
-- ----------------------------------------------------------------

ALTER TABLE `ss_dbprefixnewsfeeds`
 CHANGE `id` `id` integer(11) UNSIGNED NOT NULL auto_increment;

ALTER TABLE `ss_dbprefixnewsfeeds`
 CHANGE `name` `name` varchar(100) NOT NULL DEFAULT '';

ALTER TABLE `ss_dbprefixnewsfeeds`
 CHANGE `alias` `alias` varchar(100) NOT NULL DEFAULT '';

ALTER TABLE `ss_dbprefixnewsfeeds`
 CHANGE `link` `link` varchar(200) NOT NULL DEFAULT '';

ALTER TABLE `ss_dbprefixnewsfeeds`
 CHANGE `checked_out` `checked_out` integer(10) UNSIGNED NOT NULL DEFAULT '0';

ALTER TABLE `ss_dbprefixnewsfeeds`
 ADD `access` tinyint UNSIGNED NOT NULL DEFAULT '0';

ALTER TABLE `ss_dbprefixnewsfeeds`
 ADD `language` char(7) NOT NULL DEFAULT '';

ALTER TABLE `ss_dbprefixnewsfeeds`
ADD `params` TEXT NOT NULL;

ALTER TABLE `ss_dbprefixnewsfeeds`
 ADD COLUMN   `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
 ADD COLUMN   `created_by` int(10) unsigned NOT NULL DEFAULT '0',
 ADD COLUMN   `created_by_alias` varchar(255) NOT NULL DEFAULT '',
 ADD COLUMN   `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
 ADD COLUMN   `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
 ADD COLUMN   `metakey` text NOT NULL,
 ADD COLUMN   `metadesc` text NOT NULL,
 ADD COLUMN   `metadata` text NOT NULL,
 ADD COLUMN   `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
 ADD COLUMN   `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
 ADD COLUMN   `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
 DROP INDEX `catid`,
 DROP INDEX `published`,
 ADD KEY `idx_access` (`access`),
 ADD KEY `idx_checkout` (`checked_out`),
 ADD KEY `idx_state` (`published`),
 ADD KEY `idx_catid` (`catid`),
 ADD KEY `idx_createdby` (`created_by`),
 ADD KEY `idx_language` (`language`),
 ADD KEY `idx_xreference` (`xreference`);

-- ----------------------------------------------------------------
-- ss_dbprefixplugins
-- ----------------------------------------------------------------

INSERT INTO `ss_dbprefixplugins` VALUES (NULL, 'Editor - CodeMirror', 'codemirror', 'editors', 1, 0, 1, 1, 0, 0, '0000-00-00 00:00:00', 'linenumbers=0\n\n');

-- ----------------------------------------------------------------
-- ss_dbprefixschemas
-- ----------------------------------------------------------------

CREATE TABLE `ss_dbprefixschemas` (
  `extensionid` int(11) NOT NULL,
  `versionid` varchar(20) NOT NULL,
  PRIMARY KEY (`extensionid`, `versionid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------------------------------------------
-- ss_dbprefixsession
-- ----------------------------------------------------------------

ALTER TABLE `ss_dbprefixsession`
 MODIFY COLUMN `session_id` VARCHAR(32);

ALTER TABLE `ss_dbprefixsession`
 MODIFY COLUMN `guest` TINYINT UNSIGNED DEFAULT 1;

ALTER TABLE `ss_dbprefixsession`
 MODIFY COLUMN `client_id` TINYINT UNSIGNED NOT NULL DEFAULT 0;

ALTER TABLE `ss_dbprefixsession`
 MODIFY COLUMN `data` VARCHAR(20480);

-- ----------------------------------------------------------------
-- ss_dbprefixtemplate_styles
-- ----------------------------------------------------------------

RENAME TABLE `ss_dbprefixmenu_template` TO `ss_dbprefixtemplate_styles`;

ALTER TABLE `ss_dbprefixtemplate_styles`
 CHANGE `id` `id` int(11) UNSIGNED NOT NULL auto_increment;

ALTER TABLE `ss_dbprefixtemplate_styles`
 CHANGE `template` `template` varchar(50) NOT NULL DEFAULT '';

ALTER TABLE `ss_dbprefixtemplate_styles`
 CHANGE `client_id` `client_id` tinyint(1) UNSIGNED NOT NULL DEFAULT '0';

ALTER TABLE `ss_dbprefixtemplate_styles`
 CHANGE `home` `home` tinyint(1) UNSIGNED NOT NULL DEFAULT '0';

ALTER TABLE `ss_dbprefixtemplate_styles`
 CHANGE `params` `params` varchar(2048) NOT NULL DEFAULT '';

ALTER TABLE `ss_dbprefixtemplate_styles`
 ADD INDEX `idx_template` (`template`);

ALTER TABLE `ss_dbprefixtemplate_styles`
 ADD INDEX `idx_home` (`home`);

-- ----------------------------------------------------------------
-- ss_dbprefixupdates (new)
-- ----------------------------------------------------------------

CREATE TABLE  `ss_dbprefixupdates` (
  `update_id` int(11) NOT NULL auto_increment,
  `update_site_id` int(11) default '0',
  `extension_id` int(11) default '0',
  `categoryid` int(11) default '0',
  `name` varchar(100) default '',
  `description` text,
  `element` varchar(100) default '',
  `type` varchar(20) default '',
  `folder` varchar(20) default '',
  `client_id` tinyint(3) default '0',
  `version` varchar(10) default '',
  `data` text,
  `detailsurl` text,
  PRIMARY KEY  (`update_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Available Updates';

-- ----------------------------------------------------------------
-- ss_dbprefixupdate_sites (new)
-- ----------------------------------------------------------------

CREATE TABLE  `ss_dbprefixupdate_sites` (
  `update_site_id` int(11) NOT NULL auto_increment,
  `name` varchar(100) default '',
  `type` varchar(20) default '',
  `location` text,
  `enabled` int(11) default '0',
  PRIMARY KEY  (`update_site_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Update Sites';

-- ----------------------------------------------------------------
-- ss_dbprefixupdate_sites_extensions (new)
-- ----------------------------------------------------------------

CREATE TABLE `ss_dbprefixupdate_sites_extensions` (
  `update_site_id` INT DEFAULT 0,
  `extension_id` INT DEFAULT 0,
  INDEX `newindex`(`update_site_id`, `extension_id`)
) ENGINE = MYISAM CHARACTER SET utf8 COMMENT = 'Links extensions to update sites';

-- ----------------------------------------------------------------
-- ss_dbprefixupdate_categories (new)
-- ----------------------------------------------------------------

CREATE TABLE  `ss_dbprefixupdate_categories` (
  `categoryid` int(11) NOT NULL auto_increment,
  `name` varchar(20) default '',
  `description` text,
  `parent` int(11) default '0',
  `updatesite` int(11) default '0',
  PRIMARY KEY  (`categoryid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Update Categories';

-- ----------------------------------------------------------------
-- ss_dbprefixweblinks
-- ----------------------------------------------------------------
ALTER TABLE `ss_dbprefixweblinks`
 CHANGE COLUMN `published` `state` tinyint (1) NOT NULL DEFAULT '0';

ALTER TABLE `ss_dbprefixweblinks`
 ADD COLUMN `access` INT UNSIGNED NOT NULL DEFAULT 1 AFTER `approved`;

ALTER TABLE `ss_dbprefixweblinks`
 ADD `language` char(7) NOT NULL DEFAULT '';

ALTER TABLE `ss_dbprefixweblinks`
 ADD COLUMN   `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
 ADD COLUMN   `created_by` int(10) unsigned NOT NULL DEFAULT '0',
 ADD COLUMN   `created_by_alias` varchar(255) NOT NULL DEFAULT '',
 ADD COLUMN   `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
 ADD COLUMN   `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
 ADD COLUMN   `metakey` text NOT NULL,
 ADD COLUMN   `metadesc` text NOT NULL,
 ADD COLUMN   `metadata` text NOT NULL,
 ADD COLUMN   `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if link is featured.',
 ADD COLUMN   `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
 ADD COLUMN   `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
 ADD COLUMN   `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
 DROP  KEY `catid`,
 ADD   KEY `idx_access` (`access`),
 ADD   KEY `idx_checkout` (`checked_out`),
 ADD   KEY `idx_state` (`state`),
 ADD   KEY `idx_catid` (`catid`),
 ADD   KEY `idx_createdby` (`created_by`),
 ADD   KEY `idx_featured_catid` (`featured`,`catid`),
 ADD   KEY `idx_language` (`language`),
 ADD   KEY `idx_xreference` (`xreference`);
-- ----------------------------------------------------------------
-- Reconfigure the admin module permissions
-- ----------------------------------------------------------------

UPDATE `ss_dbprefixcategories`
 SET access = access + 1;

UPDATE `ss_dbprefixcontact_details`
 SET access = access + 1;

UPDATE `ss_dbprefixcontent`
 SET access = access + 1;

UPDATE `ss_dbprefixmenu`
 SET access = access + 1;

UPDATE `ss_dbprefixmodules`
 SET access = access + 1;

UPDATE `ss_dbprefixplugins`
 SET access = access + 1;

UPDATE `ss_dbprefixsections`
 SET access = access + 1;

-- ----------------------------------------------------------------
-- Table drops.
-- ----------------------------------------------------------------

DROP TABLE `ss_dbprefixgroups`;

-- Note, devise the migration
DROP TABLE `ss_dbprefixcore_acl_aro`;
DROP TABLE `ss_dbprefixcore_acl_aro_map`;
DROP TABLE `ss_dbprefixcore_acl_aro_groups`;
DROP TABLE `ss_dbprefixcore_acl_groups_aro_map`;
DROP TABLE `ss_dbprefixcore_acl_aro_sections`;


-- ----------------------------------------------------------------
-- Add an entry to the extensions (for the app)
-- Add an entry to the schema table (for this migration)
-- ----------------------------------------------------------------
INSERT INTO ss_dbprefixextensions (name, type, element, protected) VALUES ('Joomla! CMS', 'package', 'joomla', 1);
INSERT INTO ss_dbprefixschema VALUES(LAST_INSERT_ID()), '20090622');

-- Parameter conversions todo

DROP TABLE `ss_dbprefixcore_log_items`;
DROP TABLE `ss_dbprefixstats_agents`;
